//+------------------------------------------------------------------+
//|                                     MAvsPrice_Reversal_System_v1 |
//|                                    Copyright (c) 2008, latimeria |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2008, latimeria"

// You Need Custom Indicator named <Support and Resistance> to make this EA work.

//parameters
extern string  SystemExp = "<<< System Select >>>";
extern string  AboutSystemType = "Use MA as  1=BreakOut, 2=Resistance";
extern int     SystemType=2;
extern string  SignalReveseExit_note = "Signal Reverse Exit works only in System 2";
extern bool    UseSignalReveseExit = false;

//parameters
extern string  ParamExp = "<<< Indicator Parameters >>>";
extern int     MA_Period=50;  // PERIOD
extern string  MA_Method_note = "0=SMA, 1=EMA, 2=SMMA, 3=LWMA";
extern int     MA_Method=1;   // MODE
extern string  MA_Price_note = "0=Cl, 1=Op, 2=Hi, 3=Lo, 4=Med, 5=Typ, 6=Weigh";
extern int     MA_Price=4;    // PRICE
extern int     MA_Shift=0;    // SHIFT

//MA Filter
extern string  MAFilterExp = "<<< MA Filter Settings >>>";
extern bool    UseMAFilter = false;
extern int     F_MA_Period=100;
extern int     F_MA_Method=1;
extern int     F_MA_Price=4;
extern string  F_AboutMATimeFrame = "0=Chart 1=M1 2=M5 3=M15 4=M30 5=H1 6=H4 7=D1";
extern int     F_MA_TimeFrame=0;

//Trade Switch
extern string  TradeSwitchExp = "<<< Trade Switch >>>";
extern bool    Buy = true ;
extern bool    Sell = true ;
extern bool    WeekendClose = true ;
extern int     WeekendCloseServerTime = 23 ;

//PositionSizing
extern string  PSExp = "<<< Position Sizing >>>";
extern double  FixLot=0.1; // if you don't use PS, this lot size is used.
extern bool    PositionSizing = true ;
extern double  PS_RiskRate = 0.1;

//Initial Stop
extern string  InitialSLExp = "<<< Initial StopLoss >>>";
extern string  AboutInitStop = "1=Multiple of Daily ATR,  2=Fixed SL Pips";
extern int     InitialStop_Method = 1 ;
extern int     ATR_Period = 30;
extern double  InitialStopATR = 0.7 ;
extern int     Fixed_SL = 60;

//TakeProfit
extern string  TakeProfitExp = "<<< Take Profit (& StopLoss for S&R)>>>";
extern string  TakeProfit_note = "0=No TP,  1=Multiple of SL,  2=Fixed TP Pips 3=Use S&R";
extern int     TakeProfit_Method = 0;
extern double  TP_Multiple = 1.8;
extern int     Fixed_TP = 150;
extern string  AboutSRMODE = "--- S&R Mode Setting ---";
extern double  SR_Multiple = 0.8;
extern double  TPvsSL_Ratio = 0.8;

//Trailing Stop
extern string  TrailMethodExp = "<<< Trailing Stop Method >>>";
extern string  Trail_Method_note = "0=Trail_OFF, 1=ATR_Mode, 2=FixPips_Mode, 3=Profit_Mode";
extern int     TRAIL_Method = 1;

extern string  AboutTrail_Method1 = "--- 1. You can change Trailing ATR Multiple ---";
extern double  Trail_ATR = 0.7;
extern string  AboutTrail_Method2 = "--- 2. You can change Trailing Pips ---";
extern int     Trail_Pips = 200;
extern string  AboutTrail_Method3 = "--- 3. You can change Trailing Profit to Reserve ---";
extern double  Profit_to_Reserve = 0.2;

//Miscellaneous Settings
extern string  MiscExp = "<<< Miscellaneous Settings >>>";
extern int     Slippage = 3;
extern bool    UseMicrolot = true ;
extern bool    ShowCurrentEntryPrice = true ;
extern bool    Alert_On = true ;
extern bool    Sound_On = true ;

//magic number
extern int MAGIC = 444444;

//EA name
string  EANAME="MAvsPrice_Reversal_v1";
string  EASHORTNAME="MAvsPrice_v1";


//+------------------------------------------------------------------+
//| start                                                            |
//+------------------------------------------------------------------+
int start()
{
	//Get Current Position
   int pos = CalculateCurrentOrders();

	//Draw Current Entry Price
   if(ShowCurrentEntryPrice)
   {
      ObjectDelete("CurrentEntry"); 
      if(pos != 0)
      {
         double CurEntryPrice = GetCurrentEntryPrice();
         DrawCurEntryPrice("CurrentEntry", Time[0], CurEntryPrice , Red);
      }
   }
   
   //WeekEnd Close
   if(WeekendClose) //Close Position and Cancel Trade before WeekEnd
   {
      if (DayOfWeek()==5 && TimeHour(Time[0]) >= WeekendCloseServerTime) 
      { ClosePositions(); return(0); }
   }

   // Trailing Stop
   if(TRAIL_Method>3 || TRAIL_Method<0) TRAIL_Method = 1; // error correction
   if( (pos > 0 || pos < 0) && TRAIL_Method != 0 ) MultiModeTrailingStop();

	//Trade Only Bar Opening
   if(Volume[0]>1 || IsTradeAllowed()==false) return(0);
         

	//Get Indicator values
   if(MA_Method>3 || MA_Method<0) MA_Method = 0; // error correction
   if(MA_Price>6 || MA_Price<0) MA_Price = 0; // error correction
      
   double MA_0 = iMA(NULL,0, MA_Period, MA_Shift, MA_Method, MA_Price,0);
   double MA_1 = iMA(NULL,0, MA_Period, MA_Shift, MA_Method, MA_Price,1);
   double MA_2 = iMA(NULL,0, MA_Period, MA_Shift, MA_Method, MA_Price,2);
   double MA_3 = iMA(NULL,0, MA_Period, MA_Shift, MA_Method, MA_Price,3);
   double MA_4 = iMA(NULL,0, MA_Period, MA_Shift, MA_Method, MA_Price,4);
   
   int MA_Dir_0,MA_Dir_1,MA_Dir_2,MA_Dir_3,MA_Dir_4 ;
   if(MA_0>MA_1) MA_Dir_0 = 1; else MA_Dir_0 = 2;
   if(MA_1>MA_2) MA_Dir_1 = 1; else MA_Dir_1 = 2;
   if(MA_2>MA_3) MA_Dir_2 = 1; else MA_Dir_2 = 2;
   if(MA_3>MA_4) MA_Dir_3 = 1; else MA_Dir_3 = 2;

   // Draw Comment
   Comment(Show_Curent_System(),"\n",Show_MA_Setting(),"\n",Show_PSandSTOP_Settings(),"\n",Show_TrailingandTP(),"\n",Show_Misc_Settings());

//   Comment("MA_Dir[0]= ",MA_Dir_0," MA_Dir[1]= ",MA_Dir_1," MA_Dir[2]= ",MA_Dir_2," MA_Dir[3]= ",MA_Dir_3," MA_Dir[4]= ",MA_Dir_4)

   if(SystemType < 1 || SystemType > 2) SystemType = 1;// error correction

   // SignalReverse Exit
   if(pos != 0 && SystemType == 2 && UseSignalReveseExit) 
   {
      if(pos > 0) if(MA_Dir_1 == 2 && MA_Dir_2 == 2) ClosePositions(); // Close Buy
      if(pos < 0) if(MA_Dir_1 == 1 && MA_Dir_2 == 1) ClosePositions(); // Close Sell
   }

	//Entry_Logic
   int TRADE_DIRECTION = 0;

	//Judge if price crossed MA line
   if(SystemType == 1) // Use MA as BreakOut
   {
      if(MA_Dir_1 == 1 && MA_Dir_2 == 1 && Open[1] > MA_1 && Close[1] < MA_1) TRADE_DIRECTION = 2; //Sell
      if(MA_Dir_1 == 2 && MA_Dir_2 == 2 && Open[1] < MA_1 && Close[1] > MA_1) TRADE_DIRECTION = 1; //Buy
   }
   if(SystemType == 2) // Use MA as Resistance
   {
      if(MA_Dir_1 == 1 && MA_Dir_2 == 1 && Open[1] > MA_1 && Close[1] < MA_1) TRADE_DIRECTION = 1; //Buy
      if(MA_Dir_1 == 2 && MA_Dir_2 == 2 && Open[1] < MA_1 && Close[1] > MA_1) TRADE_DIRECTION = 2; //Sell
   }

	//MA Filter
   int F_MA_DIRECTION = 0;
   if(UseMAFilter)
   {
      double F_MA_1 = iMA(NULL,SelectTimeFrame(F_MA_TimeFrame),F_MA_Period,0,F_MA_Method,F_MA_Price,1);
      double F_MA_2 = iMA(NULL,SelectTimeFrame(F_MA_TimeFrame),F_MA_Period,0,F_MA_Method,F_MA_Price,2);
      if(F_MA_1 > F_MA_2) F_MA_DIRECTION = 1; else F_MA_DIRECTION = 2;
      if(TRADE_DIRECTION != F_MA_DIRECTION) TRADE_DIRECTION = 0;
   }
      
	//Open Order
   if(pos == 0)
   {
      //Buy
      if(TRADE_DIRECTION == 1)
      {
         if(Buy) BuyOrder();
      }

      // Sell
      if(TRADE_DIRECTION == 2)
      {
         if(Sell) SellOrder();
      }
   }

   return(0);
}
// end of Start Function


//+------------------------------------------------------------------+
//| ClosePositions                                                   |
//+------------------------------------------------------------------+
void ClosePositions()
{
   //Total Positions
   int total = OrdersTotal();
   if (total > 0)
   {
      for (int i = total - 1; i >=0; i--)
      {
         //Select Position
         bool selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol())
         {
            //Get Position Type
            int type = OrderType();
            
            bool success = false;
            
            switch (type)
            {
               case OP_BUY:
                  double bid = MarketInfo(OrderSymbol(), MODE_BID);
                  success = OrderClose(OrderTicket(),OrderLots(), bid, 3, CLR_NONE);
                  if(Alert_On) Alert(EASHORTNAME,"_Close ", Symbol(), " at ", Bid," Lots ",OrderLots()); 
                  if(Sound_On) PlaySound("alert2.wav");
                  break;
               case OP_SELL:
                  double ask = MarketInfo(OrderSymbol(), MODE_ASK);
                  success = OrderClose(OrderTicket(),OrderLots(), ask, 3, CLR_NONE);
                  if(Alert_On) Alert(EASHORTNAME,"_Close ", Symbol(), " at ", Ask," Lots ",OrderLots());      
                  if(Sound_On) PlaySound("alert2.wav");
                  break;
            }
            
            if (!success)
            {
               Print("Error code = " + GetLastError());
            }
         }
      }
   }
} // end of ClosePositions Function

//+------------------------------------------------------------------+
//| Culculate Current Open Position                                  |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()
{
   //Open Positionsi+:Buy -:Sellj
   int i;
   int pos=0;

   // Buy Position
   int pos_buy=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
      {
         if(OrderType() == OP_BUY) pos_buy++ ;
      }
   }

   //Sell Position
   int pos_sell=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
      {
         if(OrderType() == OP_SELL) pos_sell--;
      }
   }

   //Culculate pos
   if(pos_buy>0) pos = pos_buy;
   if(pos_sell<0) pos = pos_sell;
   if(pos_sell == 0 && pos_buy == 0) pos = 0;

   return(pos);
} // end of CalculateCurrentOrders

//+------------------------------------------------------------------+
//| ATR                                                              |
//+------------------------------------------------------------------+
double ATR()
{
   double ATR = iATR(NULL,1440,ATR_Period,1);
   return(ATR);
}

//+------------------------------------------------------------------+
//| SL_Decision                                                      |
//+------------------------------------------------------------------+
double SL_Decision()
{
   if(InitialStop_Method>2 || InitialStop_Method<1) InitialStop_Method = 1; // error correction
   double SL = Fixed_SL * Point ;
   if(InitialStop_Method == 1) SL = ATR() * InitialStopATR ;
   
   return(SL);
}

//+------------------------------------------------------------------+
//| TP_Decision                                                      |TP_Ratio
//+------------------------------------------------------------------+
double TP_Decision()
{
   if(TakeProfit_Method>3 || TakeProfit_Method<0) TakeProfit_Method = 1; // error correction
   double TP = Fixed_TP * Point ;
   if(TakeProfit_Method==1) TP = SL_Decision() * TP_Multiple ;

   return(TP);
}

//+------------------------------------------------------------------+
//| Position_Sizing                                                  |
//+------------------------------------------------------------------+
double PositionSizing()
{
   double lot = FixLot;
   
   //PositionSizing
   double StopLoss = SL_Decision() ;

   if(PositionSizing)
   {
      double RiskAmount = AccountFreeMargin() * (PS_RiskRate/100) ;
      int SLpips = StopLoss/Point ;
      double PT = profit_unit(); // call function
      lot = RiskAmount/(PT * SLpips) ;
   }

   lot = NormalizeDouble(lot,GetLotDigits()) ;

   return(lot);
}

//+------------------------------------------------------------------+
//| Buy Order                                                        |
//+------------------------------------------------------------------+
void BuyOrder()
{   
   //PositionSizing
   double lot = PositionSizing();
   double StopLoss = Ask - SL_Decision();

   double TP = TP_Decision();
   double TakeProfit = Ask + TP;
   if(TakeProfit_Method==0) TakeProfit = 0 ;

   if(TakeProfit_Method == 3)
   {
      double RESISTANCE = iCustom(NULL, 0, "Support and Resistance", 0, 1); // call "resistance"
      TakeProfit = Ask + (RESISTANCE - Ask) * SR_Multiple ;
      StopLoss = Ask - (TakeProfit * TPvsSL_Ratio);
   }

   if(lot < GetMinimumLot()) return(0);
   bool OrderSuccess = OrderSend(Symbol(), OP_BUY, lot, Ask, Slippage, StopLoss, TakeProfit, EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_B", MAGIC, 0, Green);
   if(OrderSuccess)
   {
      if(Alert_On) Alert(EASHORTNAME," Buy ", Symbol(),"(",GetChartTimeFrame(),") at ", Ask," Lots ",lot);
      if(Sound_On) PlaySound("news.wav");
   }
}

//+------------------------------------------------------------------+
//| Get Minlot                                                       |
//+------------------------------------------------------------------+
double GetMinimumLot()
{
   double ML = 0.1; if(UseMicrolot) ML = 0.01;
   return(ML);
}

//+------------------------------------------------------------------+
//| GetLotDigits                                                     |
//+------------------------------------------------------------------+
int GetLotDigits()
{
   int LotDigits = 1; if(UseMicrolot) LotDigits = 2;
   return(LotDigits);
}

//+------------------------------------------------------------------+
//| Sell Order                                                       |
//+------------------------------------------------------------------+
void SellOrder()
{
   //PositionSizing
   double lot = PositionSizing();
   double StopLoss = Bid + SL_Decision();

   double TP = TP_Decision();
   
   double TakeProfit = Bid - TP;
   if(TakeProfit_Method == 0) TakeProfit = 0 ;

   if(TakeProfit_Method == 3)
   {
      double SUPPORT = iCustom(NULL, 0, "Support and Resistance", 1, 1) * SR_Multiple; // call "support"
      TakeProfit = Bid - (Bid - SUPPORT) ;
      StopLoss = Bid + (TakeProfit * TPvsSL_Ratio);
   }

   if(lot < GetMinimumLot()) return(0);
   bool OrderSuccess = OrderSend(Symbol(), OP_SELL, lot, Bid, Slippage, StopLoss, TakeProfit, EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S", MAGIC, 0, Red);
   if(OrderSuccess)
   {
      if(Alert_On) Alert(EASHORTNAME," Sell ", Symbol(),"(",GetChartTimeFrame(),") at ", Bid," Lots ",lot);
      if(Sound_On) PlaySound("news.wav");      
   }
}


//+------------------------------------------------------------------+
//| profit_unit                                                      |
//+------------------------------------------------------------------+
double profit_unit()
{
    double lot_size    =MarketInfo(Symbol(),MODE_LOTSIZE); //
    string base_currecy=StringSubstr(Symbol(),0,3);
    int    symbol_len  =StringLen(Symbol());
    string term_currecy="USD";
    if(symbol_len==6)
        term_currecy=StringSubstr(Symbol(),3,3);
    string term_pair =term_currecy+AccountCurrency();
    string xterm_pair=AccountCurrency()+term_currecy;
    string base_pair =base_currecy+AccountCurrency();
    double term_unit =1.0;
    if(base_currecy==AccountCurrency())
    { 
        term_unit=1.0/Bid;
    }
    else if(term_currecy!=AccountCurrency())
    {
        term_unit=iClose(term_pair,0,0);
        if(term_unit<=0)
        {
            term_unit=iClose(xterm_pair,0,0);
            if(term_unit<=0)
            {
                term_unit=iClose(base_pair,0,0);
            }
            else
            {
               term_unit=1.0/term_unit;
            }
        }
    }
    return(lot_size*Point*term_unit); // returns Profit/Loss per 1.0 lot * 1pip by your accout currency.
}

//+------------------------------------------------------------------+
//| GetCurrentEntryPrice                                             |
//+------------------------------------------------------------------+
double GetCurrentEntryPrice()
{
   int i; double CurEntryPrice;

   for(i=0; i<OrdersTotal(); i++)
   {
      bool selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol())
      {
         CurEntryPrice = OrderOpenPrice();
      }
   }
return(CurEntryPrice);
}

//+------------------------------------------------------------------+
//| DrawCurEntryPrice                                                |
//+------------------------------------------------------------------+
void DrawCurEntryPrice(string name, datetime TIME, double PRICE, color COLOR)
  {
   if(CalculateCurrentOrders() > 0) COLOR = Lime;
   if(CalculateCurrentOrders() < 0) COLOR = Red;

   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, TIME, PRICE);
       ObjectSet(name, OBJPROP_COLOR, COLOR);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, TIME);
       ObjectSet(name, OBJPROP_PRICE1, PRICE);
       ObjectSet(name, OBJPROP_COLOR, COLOR);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }

//+------------------------------------------------------------------+
//| GetChartTimeFrame                                                |
//+------------------------------------------------------------------+
string GetChartTimeFrame()
{   
   //^Ct[
   string TimeFrame ;
   switch(Period())
   {
      case 1:     TimeFrame = "M1";break;
      case 5:     TimeFrame = "M5"; break;
      case 15:    TimeFrame = "M15"; break;
      case 30:    TimeFrame = "M30"; break;
      case 60:    TimeFrame = "H1"; break;
      case 240:   TimeFrame = "H4"; break;
      case 1440:  TimeFrame = "D1";  break;
      case 10080: TimeFrame = "W1"; break;
      case 43200: TimeFrame = "MN1"; break;
   }
   return(TimeFrame);
}

//+------------------------------------------------------------------+
//| Select Fiter Time Frame                                          |
//+------------------------------------------------------------------+
string SelectTimeFrame(int TIMEFRAME)
{   
   //^Ct[
   string TimeFrame ;
   switch(TIMEFRAME)
   {
      case 1: TimeFrame = "PERIOD_M1"; break;
      case 2: TimeFrame = "PERIOD_M5"; break;
      case 3: TimeFrame = "PERIOD_M15"; break;
      case 4: TimeFrame = "PERIOD_M30"; break;
      case 5: TimeFrame = "PERIOD_H1"; break;
      case 6: TimeFrame = "PERIOD_H4"; break;
      case 7: TimeFrame = "PERIOD_D1";  break;
      default: F_MA_TimeFrame = 0 ;  break;
   }

   if(F_MA_TimeFrame==0)
   {
      switch(Period())
      {
         case 1:     TimeFrame = "PERIOD_M1";break;
         case 5:     TimeFrame = "PERIOD_M5"; break;
         case 15:    TimeFrame = "PERIOD_M15"; break;
         case 30:    TimeFrame = "PERIOD_M30"; break;
         case 60:    TimeFrame = "PERIOD_H1"; break;
         case 240:   TimeFrame = "PERIOD_H4"; break;
         case 1440:  TimeFrame = "PERIOD_D1";  break;
      }
   }
   
   return(TimeFrame);
}

//+------------------------------------------------------------------+
//| MultiModeTrailingStop                                            |  TRAIL_Method   0=Trail_OFF, 1=ATR_Mode, 2=FixPips_Mode, 3=Profit_Mode 
//+------------------------------------------------------------------+
void MultiModeTrailingStop()
{
   int pos,i;
   double STOP, CurrentSL, STOP_HABA, Profit;
   bool selected;

   pos = CalculateCurrentOrders();

   // Get Current Stop Loss
   CurrentSL = CheckCurrentStop();

   if(TRAIL_Method == 1) STOP_HABA = ATR()*Trail_ATR ;
   if(TRAIL_Method == 2) STOP_HABA = Trail_Pips * Point ;

if(pos > 0) //Buy Position ------------------------------------------------------------------------------
{
   if( (TRAIL_Method == 1 || TRAIL_Method == 2) && Close[1] - STOP_HABA > CurrentSL) // if ATR or Fixpips Mode
   {
      STOP = Close[1] - STOP_HABA ;
   
      // Modify Stop Loss (Buy --- ATR/FIX)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),STOP,OrderTakeProfit(),0,Violet);
         }
      }
   return(0);
   }

   if(TRAIL_Method == 3) // if ProfitMode
   {
      Profit = Bid - CurrentSL; // Culculate Current Profit by pips
      STOP = Bid - (Profit * Profit_to_Reserve);
   
      // Modify Stop Loss (Buy --- Profit)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),STOP,OrderTakeProfit(),0,Violet);
         }
      }
   return(0);
   }

} // end of Buy Trailing --------------------------------------------------------------------------------

if(pos < 0) //Sell Position
{
   // Modify Stop Loss
   if( (TRAIL_Method == 1 || TRAIL_Method == 2) && Close[1] + STOP_HABA < CurrentSL) // if ATR or Fixpips Mode
   {
      STOP = Close[1] + STOP_HABA ;

      // Modify Stop Loss (Sell --- ATR/FIX)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(),STOP,OrderTakeProfit(),0,Yellow);
         }
      }
   return(0);
   }

   if(TRAIL_Method == 3) // if ProfitMode
   {
      // Modify Stop Loss
      Profit = CurrentSL - Ask ; // Get Current Stop Loss
      STOP = Ask + (Profit * Profit_to_Reserve);

      // Modify Stop Loss (Sell --- Profit)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(),STOP,OrderTakeProfit(),0,Yellow);
         }
      }
   }

} // end of Sell Trailing --------------------------------------------------------------------------------

} // end of MultiModeTrailing()

//+------------------------------------------------------------------+
//| Get Current StopLoss                                             |
//+------------------------------------------------------------------+
double CheckCurrentStop()
{
   int pos,i;
   double CurrentSL;
   bool selected;
   
   pos = CalculateCurrentOrders();

   if(pos>0) // Buy
   {
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }
   
   if(pos<0) // Sell
   {
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }   
} // end of CheckCurrentStop


//+------------------------------------------------------------------+
//| Show Current Settings                                            |
//+------------------------------------------------------------------+
string Show_Curent_System()
{
   string CurrentSystem = "Current System = "+EASHORTNAME+"_System"+SystemType+ " (Use MA as BreakOut)";
   if(SystemType == 2) CurrentSystem = "Current System = "+EASHORTNAME+"_System"+SystemType+ " (Use MA as Resistance)";
   return(CurrentSystem);
}

//-------------------------------------------------
string Show_MA_Setting()
{
   switch(MA_Method)
   {
      case 0: string CurMA_Method = "SMA";break;
      case 1: CurMA_Method = "EMA";break;
      case 2: CurMA_Method = "SMMA";break;
      case 3: CurMA_Method = "LWMA";break;
      default:CurMA_Method = "SMA";break;
  }
   switch(MA_Price)
   {
      case 0: string CurMA_Price = "Close";break;
      case 1: CurMA_Price = "Open";break;
      case 2: CurMA_Price = "High";break;
      case 3: CurMA_Price = "Low";break;
      case 4: CurMA_Price = "Median";break;
      case 5: CurMA_Price = "Typical";break;
      case 6: CurMA_Price = "Weighted Close";break;
      default:CurMA_Price = "Close";break;
  }

   string MA_Setting = "Signal MA Setting = "+CurMA_Method +" "+MA_Period+ " (Price "+CurMA_Price+") Shift "+MA_Shift ;

   return(MA_Setting);
}

//-------------------------------------------------

string Show_PSandSTOP_Settings()
{
   // PositionSizing
   string PS_SETTING = "PositionSizing = Off(Use Fixed "+FixLot+" lot)";
   if(PositionSizing) PS_SETTING = "PositionSizing = ON "+"(AccountRisk="+DoubleToStr(PS_RiskRate,1)+")";

   // InitialStop
   string INIT_STOP = "InitialStop = Use Fixed "+Fixed_SL+" pips";
   if(InitialStop_Method==1) INIT_STOP = "InitialStop = Daily ATR Multiple ("+DoubleToStr(InitialStopATR,1)+")";
   if(InitialStop_Method>2 || InitialStop_Method<1) INIT_STOP = "InitialStop = Daily ATR Multiple ("+DoubleToStr(InitialStopATR,1)+")";


   // All Information
   string SETTINGS = PS_SETTING + " / "+INIT_STOP;

   return(SETTINGS);
}

//--------------------------------------------------------------------

string Show_TrailingandTP()
{
   // Trailing Stop
   switch(TRAIL_Method)
   {
      case 0: string TRAIL_SETTING = "Off";break;
      case 1: TRAIL_SETTING = "ON - ATR(Multiple="+DoubleToStr(Trail_ATR,1)+")";break;
      case 2: TRAIL_SETTING = "ON - Fixed "+Trail_Pips+" Pips";break;
      case 3: TRAIL_SETTING = "ON - Profit(Reserve="+DoubleToStr(Profit_to_Reserve,1)+")";break;
      default:TRAIL_SETTING = "ON - ATR(Multiple="+DoubleToStr(Trail_ATR,1)+")";break;
   }
   string TRAILINGSTOP = "Trailing Stop = "+TRAIL_SETTING;

   // TakeProfit
   switch(TakeProfit_Method)
   {
      case 0: string TP_SETTING = "Off";break;
      case 1: TP_SETTING = "Multiple of SL";break;
      case 2: TP_SETTING = "Fixed "+Fixed_TP+" Pips";break;
      case 3: TP_SETTING = "S&R Multiple(Multiple="+DoubleToStr(SR_Multiple,1)+", TPvsSL="+DoubleToStr(TPvsSL_Ratio,1)+")";break;
      default:TP_SETTING = "No TakeProfit";break;
   }
   string TAKEPROFIT = "TakeProfit = "+TP_SETTING;

   // All Information
   string SETTINGS = TRAILINGSTOP+ " / "+TAKEPROFIT;

   return(SETTINGS);
}

//--------------------------------------------------------------------

string Show_Misc_Settings()
{
   // MA Filter
   string MA_FILTER = "MA Filter = Off";
   if(UseMAFilter) MA_FILTER = " MA Filter = ON "+"(Method="+F_MA_Method+"/Price="+F_MA_Price+"/TimeFrame="+F_MA_TimeFrame+")";

   // WeekEnd Close
   string WE_CLOSE = "WeekEnd_Close = Off";
   if(WeekendClose) WE_CLOSE = "WeekEnd_Close = ON "+"(Close at "+WeekendCloseServerTime+":00)";

   // Microlot
   string MICROLOT = "Use Microlot = Off";
   if(UseMicrolot) MICROLOT = "Use Microlot = ON";

   // All Information
   string SETTINGS = MA_FILTER + " / "+WE_CLOSE+ " / "+MICROLOT;

   return(SETTINGS);
}


